----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date: 10/30/2023 10:05:44 AM
-- Design Name: 
-- Module Name: LCD_Backlight - Behavioral
-- Project Name: 
-- Target Devices: 
-- Tool Versions: 
-- Description: 
-- 
-- Dependencies: 
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
-- 
----------------------------------------------------------------------------------


library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if using
-- arithmetic functions with Signed or Unsigned values
--use IEEE.NUMERIC_STD.ALL;

-- Uncomment the following library declaration if instantiating
-- any Xilinx leaf cells in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity LCD_Backlight is
    port(
        clk_out_25M : in STD_LOGIC;
         brightness_in : in STD_LOGIC_VECTOR ( 2 downto 0);
         pwm_out : out STD_LOGIC;
         led_on : out STD_LOGIC
         );
end LCD_Backlight;

architecture Behavioral of LCD_Backlight is

begin
pwm : process (clk_out_25M)
variable pwm_count: unsigned(9 downto 0) := "0000000000";
variable brightness_value: unsigned(9 downto 0) := "0001111111";
begin
led_on <= '1';
if rising_edge(clk_out_25M) then
    brightness_value(9 downto 7) := unsigned(brightness_in);
    pwm_count := pwm_count + 1;
    if pwm_count = 1023 then
        pwm_count := "0000000000";
    end if;
    if to_integer(brightness_value) >  to_integer(pwm_count) then
        pwm_out <= '1';
    else
        pwm_out <= '0';
    end if; 
end if;
end process pwm;

end Behavioral;
